﻿init python:
    import pygame
    class actor:
        def __init__(self, name, x, y, level, portrait):
            self.name = name
            self.max_hp = 100
            self.hp = 100
            self.max_food = 100
            self.food = 100
            self.exp = 0
            self.level = level
            self.portrait = portrait

            self.attack = 2
            self.armor = 2

            self.alpha = 0
            self.x = 0
            self.y = 0
            self.direction = "down"
            self.stat = "idle"
            self.busy = 0
            self.locked = False
        def face(self, target, away = False, ret = False):
            x = self.x -target.x
            y = self.y - target.y
            if away:
                x = -x
                y = -y
            if abs(x) > abs(y):
                if x > 0:
                    direction = "left"
                else:
                    direction = "right"
            else:
                if y > 0:
                    direction = "up"
                else:
                    direction = "down"
            if ret:
                return direction
            else:
                self.direction = direction
        def tick(self):
            if self.busy > 0:
                self.busy -= 1
            if self.busy < 1:
                self.stat = "idle"
        def unlock(self):
            self.locked = False
    class equip:
        def __init__(self):
            self.total_attack = 0
            self.total_armor = 0
            self.equipment = {
                "left" : [],
                "hands" : [],
                "head" : [],
                "neck" : [],
                "right" : [],

                "fingers" : [],
                "feet" : [],
                "chest" : [],
                "quick_2" : [],
                "bag" : [],
            }
            self.calculate_equipment()

        def calculate_equipment(self):
            attack = 0
            armor = 0
            for j in self.equipment:
                for i in self.equipment[j]:
                    if isinstance(i, equipment):
                        attack += i.attack
                        armor += i.armor
            self.total_attack = attack + self.attack
            self.total_armor = armor + self.armor
            renpy.restart_interaction()

        def item_equip(self, item, slot):

            if len(self.equipment[slot]):
                taken = self.equipment[slot].pop()
                self.add_item(stack(taken, 1))

            self.equipment[slot].append(item)
            self.remove_item(stack(item, 1))
            self.calculate_equipment()

        def get_filtered_items(self, filter):
            items = []
            for i in range(self.current_bag[0], self.current_bag[1]):
                if self.items[i] and filter in self.items[i].item.tags:
                    items.append(self.items[i])
            
            Show("select_item", items = items, inv = self, filter = filter)()



