﻿init python:
    def not_interested(a, b):
        for i in a:
            if i in b:
                return True
        else:
            return False

    def buy_one(index, seller, buyer):
        if seller.items[index]:
            item = seller.items[index]
            # if not_interested(item.item.tags, buyer.reject):
            #     msg.msg("{} isn't interested in that.".format(buyer.name))
            if buyer.cash >= item.item.value:
                seller.cash += item.item.value
                buyer.cash -= item.item.value
                seller.remove_item(stack(item.item, 1))
                buyer.add_item(stack(item.item, 1))
            else:
                msg.msg("{} doesn't have enough cash.".format(buyer.name))

    def buy_all(index, seller, buyer):
        if seller.items[index]:
            item = seller.items[index]
            # if not_interested(item.item.tags, buyer.reject):
            #     msg.msg("{} isn't interested in that.".format(buyer.name))
            if buyer.cash >= item.item.value * item.quantity:
                seller.cash += item.item.value * item.quantity
                buyer.cash -= item.item.value * item.quantity
                seller.remove_item(item)
                buyer.add_item(item)
            else:
                msg.msg("{} doesn't have enough cash.".format(buyer.name))
            
screen shop(seller, buyer):
    modal True
    style_prefix "inventory"
    button:
        yalign 1.0
        text "Leave"
        action Return()
    drag:
        align .5,.5
        hbox:
            for bag, other in zip([seller, buyer], [buyer, seller]):
                vbox:
                    frame:
                        padding 10,10 xsize 40+(128*5)
                        vbox:
                            text bag.name
                            hbox: # Bags
                                xfill True
                                hbox:
                                    for n, i in enumerate(bag.bags):
                                        button:
                                            text i[1]
                                            action Function(bag.set_bag, n), SelectedIf(bag.current_bag[2] == n)
                                text str(bag.cash) align 1.0,.5
                            hbox:
                                box_wrap True spacing 4 box_wrap_spacing 4
                                for i in range(bag.current_bag[0], bag.current_bag[1]):
                                    button: # Item
                                        xysize 128,128 padding 0,0
                                        action Function(buy_one, i, seller = bag, buyer = other)
                                        alternate Function(buy_all, i, seller = bag, buyer = other)
                                        if bag.items[i]:
                                            tooltip bag.items[i]
                                            fixed:
                                                add bag.items[i].item.icon
                                                if not bag.items[i].quantity == 1:
                                                    frame:
                                                        align 1.0,1.0 padding 4,4
                                                        text str(bag.items[i].quantity) size 20





    drag: # Tests remove these later
        pos 100,100
        frame:
            vbox:
                text "Tests"
                button:
                    text "Add item"
                    action Function(seller.got, stack(renpy.random.choice(all_items), 1))
                button:
                    text "Add items"
                    action Function(seller.got, [stack(all_items[0], 1), stack(all_items[1], 1), stack(all_items[2], 1), stack(all_items[3], 1), stack(all_items[4], 1), stack(all_items[5], 1)])
                button:
                    text "Add Money"
                    action Function(seller.got, renpy.random.randint(0,100))
                button:
                    text "Add bag"
                    action Function(seller.add_bag, [5, "test"])


